/**
 * @package flib
 */
//---------------------------------------------------------------------------
#ifndef _fstring_exc_H_
#define _fstring_exc_H_

#include "fexception.h"

//=================================================================
//                  FStringException
//=================================================================
class FStringException : public FException {
public:
    	FStringException(const char *_fmt, ...) {
	    	va_list arg;
		    va_start(arg, _fmt);
    		init("FStringException", _fmt, arg);
	    	va_end(arg);
    	}
};

//=================================================================
//                  FStringListException
//=================================================================
class FStringListException : public FException {
public:
    	FStringListException(const char *_fmt, ...) {
	    	va_list arg;
		    va_start(arg, _fmt);
    		init("FStringListException", _fmt, arg);
	    	va_end(arg);
    	}
//        FStringListException(const FString &_msg) {init("FStringListException", _msg.Str());}
};

//=================================================================
//                  FStringTableException
//=================================================================
class FStringTableException : public FException {
public:
    	FStringTableException(const char *_fmt, ...) {
	    	va_list arg;
		    va_start(arg, _fmt);
    		init("FStringTableException", _fmt, arg);
	    	va_end(arg);
    	}
};
//---------------------------------------------------------------------------
#endif
