#ifndef VCA_FDPOLL_H
#define VCA_FDPOLL_H

#include <ul_htimer.h>
#include <ul_gsa.h>
#include <ul_gsacust.h>

typedef int vca_fd_t;

#define VCAFD_RD 1
#define VCAFD_WR 2

struct vcaFdNode_t;
struct vcaFdPoll_t;

typedef void vcaFdReady_t(struct vcaFdNode_t *nd, int event_type, struct vcaFdPoll_t *p);

typedef struct vcaFdNode_t
{
    vca_fd_t fd;
    vcaFdReady_t *ready;
    int event_type; /*not used*/
} vcaFdNode_t;

vcaFdNode_t* vcaFdNode_init(vcaFdNode_t *nd, int fd, int event_type);
void vcaFdNode_destroy(vcaFdNode_t *nd);

typedef struct vcaFdPoll_t
{
    gsa_array_field_t fdnode_list;
    struct pollfd *pollfd_array;
    int pollfd_size;
    int need_resync:1;
} vcaFdPoll_t;

vcaFdPoll_t* vcaFdPoll_init(vcaFdPoll_t *p);
void vcaFdPoll_destroy(vcaFdPoll_t *p);
void vcaFdPoll_insert(vcaFdPoll_t *p, vcaFdNode_t *nd);
void vcaFdPoll_detach(vcaFdPoll_t *p, vcaFdNode_t *nd);

int vcaFdPoll_poll(vcaFdPoll_t *p, ul_htim_diff_t timeout);

#endif // VCA_FDPOLL_H

