/**************************************************
 * interface for every HW module used by canslave *
 * every loaded DLL should export this symbols    *
 **************************************************/

#ifndef _VCA_HWMOD_H
#define _VCA_HWMOD_H

#ifndef __RTL__
#include <inttypes.h>
#else /*__RTL__*/
#include <linux/types.h>
#endif /*__RTL__*/

#include <sui_dinfo.h>
#include <sui_dtreemem.h>

#ifdef __cplusplus
extern "C" {
#endif

/**
 * init_module - module initialization function obviously called by working_thread_function() when it starts.
 *               for example see nascanhw.c   
 */
int init_module(void);

/**
 * cleanup_module - module cleanup function obviously called by working_thread_function() when it finish.
 *               for example see nascanhw.c.   
 *               Function is of type void (*routine) (void *); because void pthread_cleanup_push (routine, arg) needs it.
 */
void cleanup_module(void *arg);

/**
 * get_dtreemem_node
 *
 * Return: node containing dir of exported dinfos
 */
sui_dtree_memnode_t* get_dtreemem_node(void);

#ifdef __cplusplus
} /* extern "C"*/
#endif

#endif
