#ifndef VCA_POLL_FDNODECAN_H
#define VCA_POLL_FDNODECAN_H

#include <can_vca.h>
#include <vca_fdpoll.h>
#include <ul_evcbase.h>

#define VCA_MSG_EVCODE_MSGRX        0x10
#define VCA_MSG_EVCODE_MSGRX_STD    0x11
#define VCA_MSG_EVCODE_MSGRX_RTR    0x12
#define VCA_MSG_EVCODE_MSGRX_RANGE  0x12
#define VCA_MSG_EVCODE_ERROR        0x20
#define VCA_MSG_EVCODE_ERROR_MSGTX  0x21
#define VCA_MSG_EVCODE_ERROR_RX     0x22

int vca_msg_propagate_event(evc_link_t *link, va_list args);

struct vcaNet_t;

typedef struct vcaFdNodeCan_t 
{
   vcaFdNode_t fdnode;
   vca_handle_t vcah; /* usefull only if vca_handle_t is not int */
   struct vcaNet_t *cannet;
   evc_tx_hub_t tx_hub;
} vcaFdNodeCan_t;

/**
 * vcaFdNodeCan_init - init/create CAN fdpoll node
 * @dev_name name of CAN device to open
 */
vcaFdNodeCan_t* vcaFdNodeCan_init(vcaFdNodeCan_t *nd, const char *dev_name);
void vcaFdNodeCan_destroy(vcaFdNodeCan_t *nd);

#endif // VCA_POLL_FDNODECAN_H

